/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreAnnotation.TCoreAnnotationPath;
import de.ship.db.tables.TCoreDevice.TCoreDevicePath;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreElementHierarchyAndGroup.TCoreElementHierarchyAndGroupPath;
import de.ship.db.tables.TCoreElementnote.TCoreElementnotePath;
import de.ship.db.tables.TCoreElementpublic.TCoreElementpublicPath;
import de.ship.db.tables.TCoreElementrole.TCoreElementrolePath;
import de.ship.db.tables.TCoreElementtype.TCoreElementtypePath;
import de.ship.db.tables.TCoreLifetime.TCoreLifetimePath;
import de.ship.db.tables.TCoreLogic.TCoreLogicPath;
import de.ship.db.tables.TCoreLogiccond.TCoreLogiccondPath;
import de.ship.db.tables.TCoreLogicorgrp.TCoreLogicorgrpPath;
import de.ship.db.tables.TCorePrivilege.TCorePrivilegePath;
import de.ship.db.tables.TCoreProcesstype.TCoreProcesstypePath;
import de.ship.db.tables.TCoreProcessvar.TCoreProcessvarPath;
import de.ship.db.tables.TCorePublic.TCorePublicPath;
import de.ship.db.tables.TCoreRepeatgrp.TCoreRepeatgrpPath;
import de.ship.db.tables.TCoreStage.TCoreStagePath;
import de.ship.db.tables.TCoreStudy.TCoreStudyPath;
import de.ship.db.tables.TCoreStudygroup.TCoreStudygroupPath;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TCoreUmls.TCoreUmlsPath;
import de.ship.db.tables.TCoreVargrp.TCoreVargrpPath;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.TCoreVariableSegment.TCoreVariableSegmentPath;
import de.ship.db.tables.TDmMaillist.TDmMaillistPath;
import de.ship.db.tables.TDmTabledef.TDmTabledefPath;
import de.ship.db.tables.TImportMapping.TImportMappingPath;
import de.ship.db.tables.TInputDisplayvar.TInputDisplayvarPath;
import de.ship.db.tables.TInputExport.TInputExportPath;
import de.ship.db.tables.TInputHelpparam.TInputHelpparamPath;
import de.ship.db.tables.TInputLabel.TInputLabelPath;
import de.ship.db.tables.TInputParam.TInputParamPath;
import de.ship.db.tables.TInputVariable.TInputVariablePath;
import de.ship.db.tables.TInputWebform.TInputWebformPath;
import de.ship.db.tables.records.TCoreElementHierarchyRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementHierarchy extends TableImpl<TCoreElementHierarchyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_element_hierarchy</code>
     */
    public static final TCoreElementHierarchy T_CORE_ELEMENT_HIERARCHY = new TCoreElementHierarchy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreElementHierarchyRecord> getRecordType() {
        return TCoreElementHierarchyRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_element_hierarchy.key_element</code>.
     * unique element id
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique element id");

    /**
     * The column
     * <code>common_dd.t_core_element_hierarchy.key_element_type</code>.
     * reference to element type
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER.nullable(false), this, "reference to element type");

    /**
     * The column
     * <code>common_dd.t_core_element_hierarchy.key_parent_element</code>.
     * reference to element id of parent element
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "reference to element id of parent element");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.dn</code>. birth name
     * of this element
     */
    public final TableField<TCoreElementHierarchyRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB.nullable(false), this, "birth name of this element");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.order_nr</code>.
     * order number
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "order number");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.short_name</code>.
     * short name
     */
    public final TableField<TCoreElementHierarchyRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB.nullable(false), this, "short name");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.is_public</code>. is
     * public? 1 = yes, 0 = no
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER.nullable(false), this, "is public? 1 = yes, 0 = no");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.hier_lang</code>.
     * reference to language key
     */
    public final TableField<TCoreElementHierarchyRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "reference to language key");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.stage</code>. stage
     * of element; see T_CORE_STAGE for details
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER.nullable(false).defaultValue(DSL.field(DSL.raw("6"), SQLDataType.INTEGER)), this, "stage of element; see T_CORE_STAGE for details");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.lastchange</code>.
     */
    public final TableField<TCoreElementHierarchyRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.fk_right_id</code>.
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> FK_RIGHT_ID = createField(DSL.name("fk_right_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.fk_privilege</code>.
     */
    public final TableField<TCoreElementHierarchyRecord, Integer> FK_PRIVILEGE = createField(DSL.name("fk_privilege"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.origin</code>.
     */
    public final TableField<TCoreElementHierarchyRecord, JSONB> ORIGIN = createField(DSL.name("origin"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.unique_name</code>.
     */
    public final TableField<TCoreElementHierarchyRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_element_hierarchy.prefix_short</code>.
     */
    public final TableField<TCoreElementHierarchyRecord, String> PREFIX_SHORT = createField(DSL.name("prefix_short"), SQLDataType.CLOB, this, "");

    private TCoreElementHierarchy(Name alias, Table<TCoreElementHierarchyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreElementHierarchy(Name alias, Table<TCoreElementHierarchyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_element_hierarchy</code> table
     * reference
     */
    public TCoreElementHierarchy(String alias) {
        this(DSL.name(alias), T_CORE_ELEMENT_HIERARCHY);
    }

    /**
     * Create an aliased <code>common_dd.t_core_element_hierarchy</code> table
     * reference
     */
    public TCoreElementHierarchy(Name alias) {
        this(alias, T_CORE_ELEMENT_HIERARCHY);
    }

    /**
     * Create a <code>common_dd.t_core_element_hierarchy</code> table reference
     */
    public TCoreElementHierarchy() {
        this(DSL.name("t_core_element_hierarchy"), null);
    }

    public <O extends Record> TCoreElementHierarchy(Table<O> path, ForeignKey<O, TCoreElementHierarchyRecord> childPath, InverseForeignKey<O, TCoreElementHierarchyRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_ELEMENT_HIERARCHY);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreElementHierarchyPath extends TCoreElementHierarchy implements Path<TCoreElementHierarchyRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreElementHierarchyPath(Table<O> path, ForeignKey<O, TCoreElementHierarchyRecord> childPath, InverseForeignKey<O, TCoreElementHierarchyRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreElementHierarchyPath(Name alias, Table<TCoreElementHierarchyRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreElementHierarchyPath as(String alias) {
            return new TCoreElementHierarchyPath(DSL.name(alias), this);
        }

        @Override
        public TCoreElementHierarchyPath as(Name alias) {
            return new TCoreElementHierarchyPath(alias, this);
        }

        @Override
        public TCoreElementHierarchyPath as(Table<?> alias) {
            return new TCoreElementHierarchyPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_ELEMENT_HIERARCHY_PARENT, Indexes.IDX_ELEMENT_HIERARCHY_STAGE, Indexes.T_CORE_ELEMENT_HIERARCHY_UNIQUE_NAME_IDX);
    }

    @Override
    public Identity<TCoreElementHierarchyRecord, Integer> getIdentity() {
        return (Identity<TCoreElementHierarchyRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreElementHierarchyRecord> getPrimaryKey() {
        return Keys.PK_KEY_ELEMENT;
    }

    @Override
    public List<UniqueKey<TCoreElementHierarchyRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_ELEMENT_HIERARCHY_DN, Keys.T_CORE_ELEMENT_HIERARCHY_UNIQUE_NAME_KEY);
    }

    @Override
    public List<ForeignKey<TCoreElementHierarchyRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_ELEMENT_HIERARCHY__FK_KEY_ELEMENT_TYPE, Keys.T_CORE_ELEMENT_HIERARCHY__FK_KEY_PARENT_ELEMENT, Keys.T_CORE_ELEMENT_HIERARCHY__IS_PUBLIC, Keys.T_CORE_ELEMENT_HIERARCHY__FK_HIER_LANG, Keys.T_CORE_ELEMENT_HIERARCHY__FK_ELEMENT_STAGE, Keys.T_CORE_ELEMENT_HIERARCHY__FK_PRIVILEGE);
    }

    private transient TCoreElementtypePath _tCoreElementtype;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_elementtype</code> table.
     */
    public TCoreElementtypePath tCoreElementtype() {
        if (_tCoreElementtype == null)
            _tCoreElementtype = new TCoreElementtypePath(this, Keys.T_CORE_ELEMENT_HIERARCHY__FK_KEY_ELEMENT_TYPE, null);

        return _tCoreElementtype;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_ELEMENT_HIERARCHY__FK_KEY_PARENT_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    private transient TCorePublicPath _tCorePublic;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_public</code>
     * table.
     */
    public TCorePublicPath tCorePublic() {
        if (_tCorePublic == null)
            _tCorePublic = new TCorePublicPath(this, Keys.T_CORE_ELEMENT_HIERARCHY__IS_PUBLIC, null);

        return _tCorePublic;
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_ELEMENT_HIERARCHY__FK_HIER_LANG, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreStagePath _tCoreStage;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_stage</code>
     * table.
     */
    public TCoreStagePath tCoreStage() {
        if (_tCoreStage == null)
            _tCoreStage = new TCoreStagePath(this, Keys.T_CORE_ELEMENT_HIERARCHY__FK_ELEMENT_STAGE, null);

        return _tCoreStage;
    }

    private transient TCorePrivilegePath _tCorePrivilege;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_privilege</code>
     * table.
     */
    public TCorePrivilegePath tCorePrivilege() {
        if (_tCorePrivilege == null)
            _tCorePrivilege = new TCorePrivilegePath(this, Keys.T_CORE_ELEMENT_HIERARCHY__FK_PRIVILEGE, null);

        return _tCorePrivilege;
    }

    private transient TCoreAnnotationPath _tCoreAnnotation;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_annotation</code> table
     */
    public TCoreAnnotationPath tCoreAnnotation() {
        if (_tCoreAnnotation == null)
            _tCoreAnnotation = new TCoreAnnotationPath(this, null, Keys.T_CORE_ANNOTATION__T_CORE_ANNOTATION_FK_ELEMENT_FKEY.getInverseKey());

        return _tCoreAnnotation;
    }

    private transient TCoreDevicePath _tCoreDevice;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_device</code> table
     */
    public TCoreDevicePath tCoreDevice() {
        if (_tCoreDevice == null)
            _tCoreDevice = new TCoreDevicePath(this, null, Keys.T_CORE_DEVICE__FK_CORE_DEVICE_ELEMENT.getInverseKey());

        return _tCoreDevice;
    }

    private transient TCoreElementHierarchyAndGroupPath _tCoreElementHierarchyAndGroup;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy_and_group</code> table
     */
    public TCoreElementHierarchyAndGroupPath tCoreElementHierarchyAndGroup() {
        if (_tCoreElementHierarchyAndGroup == null)
            _tCoreElementHierarchyAndGroup = new TCoreElementHierarchyAndGroupPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY_AND_GROUP__FK_CORE_ELEMENT_HIERARCHY_AND_GROUP_GROUP_ID.getInverseKey());

        return _tCoreElementHierarchyAndGroup;
    }

    private transient TCoreElementnotePath _tCoreElementnote;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_elementnote</code> table
     */
    public TCoreElementnotePath tCoreElementnote() {
        if (_tCoreElementnote == null)
            _tCoreElementnote = new TCoreElementnotePath(this, null, Keys.T_CORE_ELEMENTNOTE__FK_ELEMENT.getInverseKey());

        return _tCoreElementnote;
    }

    private transient TCoreElementpublicPath _tCoreElementpublic;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_elementpublic</code> table
     */
    public TCoreElementpublicPath tCoreElementpublic() {
        if (_tCoreElementpublic == null)
            _tCoreElementpublic = new TCoreElementpublicPath(this, null, Keys.T_CORE_ELEMENTPUBLIC__T_CORE_ELEMENTPUBLIC_FK_ELEMENT_FKEY.getInverseKey());

        return _tCoreElementpublic;
    }

    private transient TCoreElementrolePath _tCoreElementrole;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_elementrole</code> table
     */
    public TCoreElementrolePath tCoreElementrole() {
        if (_tCoreElementrole == null)
            _tCoreElementrole = new TCoreElementrolePath(this, null, Keys.T_CORE_ELEMENTROLE__FK_CORE_ELEMENTROLE.getInverseKey());

        return _tCoreElementrole;
    }

    private transient TCoreLifetimePath _tCoreLifetime;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_lifetime</code> table
     */
    public TCoreLifetimePath tCoreLifetime() {
        if (_tCoreLifetime == null)
            _tCoreLifetime = new TCoreLifetimePath(this, null, Keys.T_CORE_LIFETIME__FK_LIFETIME_ELEMENT.getInverseKey());

        return _tCoreLifetime;
    }

    private transient TCoreLogicPath _tCoreLogic;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logic</code> table
     */
    public TCoreLogicPath tCoreLogic() {
        if (_tCoreLogic == null)
            _tCoreLogic = new TCoreLogicPath(this, null, Keys.T_CORE_LOGIC__FK_LOGIC_ELEMENT.getInverseKey());

        return _tCoreLogic;
    }

    private transient TCoreLogiccondPath _fkCondVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logiccond</code> table, via the
     * <code>fk_cond_variable</code> key
     */
    public TCoreLogiccondPath fkCondVariable() {
        if (_fkCondVariable == null)
            _fkCondVariable = new TCoreLogiccondPath(this, null, Keys.T_CORE_LOGICCOND__FK_COND_VARIABLE.getInverseKey());

        return _fkCondVariable;
    }

    private transient TCoreLogiccondPath _fkCondVariable2;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logiccond</code> table, via the
     * <code>fk_cond_variable2</code> key
     */
    public TCoreLogiccondPath fkCondVariable2() {
        if (_fkCondVariable2 == null)
            _fkCondVariable2 = new TCoreLogiccondPath(this, null, Keys.T_CORE_LOGICCOND__FK_COND_VARIABLE2.getInverseKey());

        return _fkCondVariable2;
    }

    private transient TCoreProcessvarPath _tCoreProcessvarFkElementFkey;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_processvar</code> table, via the
     * <code>t_core_processvar_fk_element_fkey</code> key
     */
    public TCoreProcessvarPath tCoreProcessvarFkElementFkey() {
        if (_tCoreProcessvarFkElementFkey == null)
            _tCoreProcessvarFkElementFkey = new TCoreProcessvarPath(this, null, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_ELEMENT_FKEY.getInverseKey());

        return _tCoreProcessvarFkElementFkey;
    }

    private transient TCoreProcessvarPath _tCoreProcessvarFkReferencedElementFkey;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_processvar</code> table, via the
     * <code>t_core_processvar_fk_referenced_element_fkey</code> key
     */
    public TCoreProcessvarPath tCoreProcessvarFkReferencedElementFkey() {
        if (_tCoreProcessvarFkReferencedElementFkey == null)
            _tCoreProcessvarFkReferencedElementFkey = new TCoreProcessvarPath(this, null, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_REFERENCED_ELEMENT_FKEY.getInverseKey());

        return _tCoreProcessvarFkReferencedElementFkey;
    }

    private transient TCoreRepeatgrpPath _tCoreRepeatgrp;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_repeatgrp</code> table
     */
    public TCoreRepeatgrpPath tCoreRepeatgrp() {
        if (_tCoreRepeatgrp == null)
            _tCoreRepeatgrp = new TCoreRepeatgrpPath(this, null, Keys.T_CORE_REPEATGRP__FK_CORE_REPEATGRP_HIERARCHY.getInverseKey());

        return _tCoreRepeatgrp;
    }

    private transient TCoreStudyPath _tCoreStudy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_study</code> table
     */
    public TCoreStudyPath tCoreStudy() {
        if (_tCoreStudy == null)
            _tCoreStudy = new TCoreStudyPath(this, null, Keys.T_CORE_STUDY__FK_STUDY_ELEMENT.getInverseKey());

        return _tCoreStudy;
    }

    private transient TCoreStudygroupPath _tCoreStudygroup;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_studygroup</code> table
     */
    public TCoreStudygroupPath tCoreStudygroup() {
        if (_tCoreStudygroup == null)
            _tCoreStudygroup = new TCoreStudygroupPath(this, null, Keys.T_CORE_STUDYGROUP__T_CORE_STUDYGROUP_FK_ELEMENT_FKEY.getInverseKey());

        return _tCoreStudygroup;
    }

    private transient TCoreVargrpPath _tCoreVargrp;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_vargrp</code> table
     */
    public TCoreVargrpPath tCoreVargrp() {
        if (_tCoreVargrp == null)
            _tCoreVargrp = new TCoreVargrpPath(this, null, Keys.T_CORE_VARGRP__FK_CORE_VARGRP_HIERARCHY.getInverseKey());

        return _tCoreVargrp;
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_variable</code> table
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, null, Keys.T_CORE_VARIABLE__FK_KEY_VARIABLE.getInverseKey());

        return _tCoreVariable;
    }

    private transient TCoreVariableSegmentPath _tCoreVariableSegment;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_variable_segment</code> table
     */
    public TCoreVariableSegmentPath tCoreVariableSegment() {
        if (_tCoreVariableSegment == null)
            _tCoreVariableSegment = new TCoreVariableSegmentPath(this, null, Keys.T_CORE_VARIABLE_SEGMENT__T_CORE_VARIABLE_SEGMENT_FK_ELEMENT_FKEY.getInverseKey());

        return _tCoreVariableSegment;
    }

    private transient TDmMaillistPath _tDmMaillist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_maillist</code> table
     */
    public TDmMaillistPath tDmMaillist() {
        if (_tDmMaillist == null)
            _tDmMaillist = new TDmMaillistPath(this, null, Keys.T_DM_MAILLIST__FK_ELEMENT_KEY.getInverseKey());

        return _tDmMaillist;
    }

    private transient TDmTabledefPath _tDmTabledef;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_tabledef</code> table
     */
    public TDmTabledefPath tDmTabledef() {
        if (_tDmTabledef == null)
            _tDmTabledef = new TDmTabledefPath(this, null, Keys.T_DM_TABLEDEF__FK_TABLEDEF_ELEMENT.getInverseKey());

        return _tDmTabledef;
    }

    private transient TInputDisplayvarPath _tInputDisplayvar;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_displayvar</code> table
     */
    public TInputDisplayvarPath tInputDisplayvar() {
        if (_tInputDisplayvar == null)
            _tInputDisplayvar = new TInputDisplayvarPath(this, null, Keys.T_INPUT_DISPLAYVAR__FK_INPUTDISPLAYVAR_FORM.getInverseKey());

        return _tInputDisplayvar;
    }

    private transient TInputExportPath _tInputExport;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_export</code> table
     */
    public TInputExportPath tInputExport() {
        if (_tInputExport == null)
            _tInputExport = new TInputExportPath(this, null, Keys.T_INPUT_EXPORT__FK_INPUT_EXPORT_ELEMENT.getInverseKey());

        return _tInputExport;
    }

    private transient TInputHelpparamPath _fkInputhelpparamStudy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_helpparam</code> table, via the
     * <code>fk_inputhelpparam_study</code> key
     */
    public TInputHelpparamPath fkInputhelpparamStudy() {
        if (_fkInputhelpparamStudy == null)
            _fkInputhelpparamStudy = new TInputHelpparamPath(this, null, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_STUDY.getInverseKey());

        return _fkInputhelpparamStudy;
    }

    private transient TInputHelpparamPath _fkInputhelpparamVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_helpparam</code> table, via the
     * <code>fk_inputhelpparam_variable</code> key
     */
    public TInputHelpparamPath fkInputhelpparamVariable() {
        if (_fkInputhelpparamVariable == null)
            _fkInputhelpparamVariable = new TInputHelpparamPath(this, null, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_VARIABLE.getInverseKey());

        return _fkInputhelpparamVariable;
    }

    private transient TInputLabelPath _tInputLabel;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_label</code> table
     */
    public TInputLabelPath tInputLabel() {
        if (_tInputLabel == null)
            _tInputLabel = new TInputLabelPath(this, null, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_ELEMENT.getInverseKey());

        return _tInputLabel;
    }

    private transient TInputParamPath _tInputParam;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_param</code> table
     */
    public TInputParamPath tInputParam() {
        if (_tInputParam == null)
            _tInputParam = new TInputParamPath(this, null, Keys.T_INPUT_PARAM__FK_INPUTPARAM_VARIABLE.getInverseKey());

        return _tInputParam;
    }

    private transient TInputVariablePath _tInputVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_variable</code> table
     */
    public TInputVariablePath tInputVariable() {
        if (_tInputVariable == null)
            _tInputVariable = new TInputVariablePath(this, null, Keys.T_INPUT_VARIABLE__FK_INPUT_VARIABLE.getInverseKey());

        return _tInputVariable;
    }

    private transient TInputWebformPath _fkWebformForm;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_webform</code> table, via the
     * <code>fk_webform_form</code> key
     */
    public TInputWebformPath fkWebformForm() {
        if (_fkWebformForm == null)
            _fkWebformForm = new TInputWebformPath(this, null, Keys.T_INPUT_WEBFORM__FK_WEBFORM_FORM.getInverseKey());

        return _fkWebformForm;
    }

    private transient TInputWebformPath _fkWebformStudygen;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_webform</code> table, via the
     * <code>fk_webform_studygen</code> key
     */
    public TInputWebformPath fkWebformStudygen() {
        if (_fkWebformStudygen == null)
            _fkWebformStudygen = new TInputWebformPath(this, null, Keys.T_INPUT_WEBFORM__FK_WEBFORM_STUDYGEN.getInverseKey());

        return _fkWebformStudygen;
    }

    private transient TCoreUmlsPath _tCoreUmls;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_umls</code> table
     */
    public TCoreUmlsPath tCoreUmls() {
        if (_tCoreUmls == null)
            _tCoreUmls = new TCoreUmlsPath(this, null, Keys.T_CORE_UMLS__FK_CORE_UMLS_DN.getInverseKey());

        return _tCoreUmls;
    }

    private transient TImportMappingPath _tImportMapping;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_import_mapping</code> table
     */
    public TImportMappingPath tImportMapping() {
        if (_tImportMapping == null)
            _tImportMapping = new TImportMappingPath(this, null, Keys.T_IMPORT_MAPPING__FK_IMPORT_MAPPING_DN.getInverseKey());

        return _tImportMapping;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_logicorgrp</code> table
     */
    public TCoreLogicorgrpPath tCoreLogicorgrp() {
        return tCoreLogic().tCoreLogicorgrp();
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_processtype</code> table
     */
    public TCoreProcesstypePath tCoreProcesstype() {
        return tCoreProcessvarFkElementFkey().tCoreProcesstype();
    }

    @Override
    public TCoreElementHierarchy as(String alias) {
        return new TCoreElementHierarchy(DSL.name(alias), this);
    }

    @Override
    public TCoreElementHierarchy as(Name alias) {
        return new TCoreElementHierarchy(alias, this);
    }

    @Override
    public TCoreElementHierarchy as(Table<?> alias) {
        return new TCoreElementHierarchy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchy rename(String name) {
        return new TCoreElementHierarchy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchy rename(Name name) {
        return new TCoreElementHierarchy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementHierarchy rename(Table<?> name) {
        return new TCoreElementHierarchy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchy where(Condition condition) {
        return new TCoreElementHierarchy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementHierarchy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementHierarchy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
